
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Notification_messagesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const notification_messages = await db.notification_messages.create(
            {
                id: data.id || undefined,
        
        channel: data.channel
        ||
        null
            ,
            
        message_type: data.message_type
        ||
        null
            ,
            
        recipient: data.recipient
        ||
        null
            ,
            
        subject: data.subject
        ||
        null
            ,
            
        body: data.body
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        queued_at: data.queued_at
        ||
        null
            ,
            
        sent_at: data.sent_at
        ||
        null
            ,
            
        provider_message_id: data.provider_message_id
        ||
        null
            ,
            
        error_message: data.error_message
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await notification_messages.setUser( data.user || null, {
            transaction,
        });
        
        await notification_messages.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return notification_messages;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const notification_messagesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                channel: item.channel
            ||
            null
            ,
            
                message_type: item.message_type
            ||
            null
            ,
            
                recipient: item.recipient
            ||
            null
            ,
            
                subject: item.subject
            ||
            null
            ,
            
                body: item.body
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                queued_at: item.queued_at
            ||
            null
            ,
            
                sent_at: item.sent_at
            ||
            null
            ,
            
                provider_message_id: item.provider_message_id
            ||
            null
            ,
            
                error_message: item.error_message
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const notification_messages = await db.notification_messages.bulkCreate(notification_messagesData, { transaction });

        // For each item created, replace relation files
        

        return notification_messages;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const notification_messages = await db.notification_messages.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.channel !== undefined) updatePayload.channel = data.channel;
        
        
        if (data.message_type !== undefined) updatePayload.message_type = data.message_type;
        
        
        if (data.recipient !== undefined) updatePayload.recipient = data.recipient;
        
        
        if (data.subject !== undefined) updatePayload.subject = data.subject;
        
        
        if (data.body !== undefined) updatePayload.body = data.body;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.queued_at !== undefined) updatePayload.queued_at = data.queued_at;
        
        
        if (data.sent_at !== undefined) updatePayload.sent_at = data.sent_at;
        
        
        if (data.provider_message_id !== undefined) updatePayload.provider_message_id = data.provider_message_id;
        
        
        if (data.error_message !== undefined) updatePayload.error_message = data.error_message;
        
        
        updatePayload.updatedById = currentUser.id;

        await notification_messages.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await notification_messages.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await notification_messages.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return notification_messages;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const notification_messages = await db.notification_messages.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of notification_messages) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of notification_messages) {
                await record.destroy({transaction});
            }
        });


        return notification_messages;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const notification_messages = await db.notification_messages.findByPk(id, options);

        await notification_messages.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await notification_messages.destroy({
            transaction
        });

        return notification_messages;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const notification_messages = await db.notification_messages.findOne(
            { where },
            { transaction },
        );

        if (!notification_messages) {
            return notification_messages;
        }

        const output = notification_messages.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await notification_messages.getUser({
            transaction
        });
        
        
        output.organizations = await notification_messages.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.recipient) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'notification_messages',
                        'recipient',
                        filter.recipient,
                    ),
                };
            }
            
            if (filter.subject) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'notification_messages',
                        'subject',
                        filter.subject,
                    ),
                };
            }
            
            if (filter.body) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'notification_messages',
                        'body',
                        filter.body,
                    ),
                };
            }
            
            if (filter.provider_message_id) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'notification_messages',
                        'provider_message_id',
                        filter.provider_message_id,
                    ),
                };
            }
            
            if (filter.error_message) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'notification_messages',
                        'error_message',
                        filter.error_message,
                    ),
                };
            }
            

            
            

            
            if (filter.queued_atRange) {
                const [start, end] = filter.queued_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    queued_at: {
                    ...where.queued_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    queued_at: {
                    ...where.queued_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.sent_atRange) {
                const [start, end] = filter.sent_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    sent_at: {
                    ...where.sent_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.channel) {
                where = {
                    ...where,
                channel: filter.channel,
            };
            }
            
            if (filter.message_type) {
                where = {
                    ...where,
                message_type: filter.message_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.notification_messages.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'notification_messages',
                        'subject',
                        query,
                    ),
                ],
            };
        }

        const records = await db.notification_messages.findAll({
            attributes: [ 'id', 'subject' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['subject', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.subject,
        }));
    }

    
};

